unit test1;

interface

uses
  SysUtils, 
  Generics.Collections, 
  Aurelius.Mapping.Attributes, 
  Aurelius.Types.Blob, 
  Aurelius.Types.DynamicProperties, 
  Aurelius.Types.Nullable, 
  Aurelius.Types.Proxy, 
  Aurelius.Dictionary.Classes, 
  Aurelius.Linq;

type
  Taddress = class;
  Tcard = class;
  Tcode = class;
  Tperson = class;
  TaddressDictionary = class;
  TcardDictionary = class;
  TcodeDictionary = class;
  TpersonDictionary = class;
  
  [Entity]
  [Table('addresses')]
  [Id('Fkpid', TIdGenerator.None)]
  Taddress = class
  private
    [Column('cpid_old2', [TColumnProp.Required])]
    Fcpid_old2: Integer;
    
    [Column('date_created', [])]
    Fdate_created: Nullable<TDateTime>;
    
    [Column('date_changed', [])]
    Fdate_changed: Nullable<TDateTime>;
    
    [Column('user_created', [], 255)]
    Fuser_created: Nullable<string>;
    
    [Column('user_changed', [], 255)]
    Fuser_changed: Nullable<string>;
    
    [Column('email', [], 255)]
    Femail: Nullable<string>;
    
    [Column('emailprivate', [], 255)]
    Femailprivate: Nullable<string>;
    
    [Column('tel', [], 255)]
    Ftel: Nullable<string>;
    
    [Column('telprivate', [], 255)]
    Ftelprivate: Nullable<string>;
    
    [Column('mobil', [], 255)]
    Fmobil: Nullable<string>;
    
    [Column('mobilprivate', [], 255)]
    Fmobilprivate: Nullable<string>;
    
    [Column('company1', [], 255)]
    Fcompany1: Nullable<string>;
    
    [Column('additional1', [], 255)]
    Fadditional1: Nullable<string>;
    
    [Column('street1', [], 255)]
    Fstreet1: Nullable<string>;
    
    [Column('zipcode1', [], 255)]
    Fzipcode1: Nullable<string>;
    
    [Column('city1', [], 255)]
    Fcity1: Nullable<string>;
    
    [Column('country1', [])]
    Fcountry1: Nullable<Integer>;
    
    [Column('company2', [], 255)]
    Fcompany2: Nullable<string>;
    
    [Column('additional2', [], 255)]
    Fadditional2: Nullable<string>;
    
    [Column('street2', [], 255)]
    Fstreet2: Nullable<string>;
    
    [Column('zipcode2', [], 255)]
    Fzipcode2: Nullable<string>;
    
    [Column('city2', [], 255)]
    Fcity2: Nullable<string>;
    
    [Column('country2', [])]
    Fcountry2: Nullable<Integer>;
    
    [Column('coveraddress', [TColumnProp.Lazy])]
    [DBTypeMemo]
    Fcoveraddress: TBlob;
    
    [Column('comment', [TColumnProp.Lazy])]
    [DBTypeMemo]
    Fcomment: TBlob;
    
    [Column('new', [])]
    Fnew: Nullable<TDateTime>;
    
    [Association([TAssociationProp.Lazy, TAssociationProp.Required], CascadeTypeAll - [TCascadeType.Remove])]
    [JoinColumn('kpid', [TColumnProp.Required], 'id')]
    Fkpid: Proxy<Tperson>;
    function Getkpid: Tperson;
    procedure Setkpid(const Value: Tperson);
  public
    property cpid_old2: Integer read Fcpid_old2 write Fcpid_old2;
    property date_created: Nullable<TDateTime> read Fdate_created write Fdate_created;
    property date_changed: Nullable<TDateTime> read Fdate_changed write Fdate_changed;
    property user_created: Nullable<string> read Fuser_created write Fuser_created;
    property user_changed: Nullable<string> read Fuser_changed write Fuser_changed;
    property email: Nullable<string> read Femail write Femail;
    property emailprivate: Nullable<string> read Femailprivate write Femailprivate;
    property tel: Nullable<string> read Ftel write Ftel;
    property telprivate: Nullable<string> read Ftelprivate write Ftelprivate;
    property mobil: Nullable<string> read Fmobil write Fmobil;
    property mobilprivate: Nullable<string> read Fmobilprivate write Fmobilprivate;
    property company1: Nullable<string> read Fcompany1 write Fcompany1;
    property additional1: Nullable<string> read Fadditional1 write Fadditional1;
    property street1: Nullable<string> read Fstreet1 write Fstreet1;
    property zipcode1: Nullable<string> read Fzipcode1 write Fzipcode1;
    property city1: Nullable<string> read Fcity1 write Fcity1;
    property country1: Nullable<Integer> read Fcountry1 write Fcountry1;
    property company2: Nullable<string> read Fcompany2 write Fcompany2;
    property additional2: Nullable<string> read Fadditional2 write Fadditional2;
    property street2: Nullable<string> read Fstreet2 write Fstreet2;
    property zipcode2: Nullable<string> read Fzipcode2 write Fzipcode2;
    property city2: Nullable<string> read Fcity2 write Fcity2;
    property country2: Nullable<Integer> read Fcountry2 write Fcountry2;
    property coveraddress: TBlob read Fcoveraddress write Fcoveraddress;
    property comment: TBlob read Fcomment write Fcomment;
    property new: Nullable<TDateTime> read Fnew write Fnew;
    property kpid: Tperson read Getkpid write Setkpid;
  end;
  
  [Entity]
  [Table('cards')]
  [Id('Fid', TIdGenerator.None)]
  Tcard = class
  private
    [Column('id', [TColumnProp.Required])]
    Fid: Integer;
    
    [Column('idhex', [TColumnProp.Required], 50)]
    Fidhex: string;
    
    [Column('swid', [TColumnProp.Required])]
    Fswid: Integer;
    
    [Column('date_created', [])]
    Fdate_created: Nullable<TDateTime>;
    
    [Column('date_changed', [])]
    Fdate_changed: Nullable<TDateTime>;
    
    [Column('bibswid', [])]
    Fbibswid: Nullable<Integer>;
    
    [Association([TAssociationProp.Lazy, TAssociationProp.Required], CascadeTypeAll - [TCascadeType.Remove])]
    [JoinColumn('pid', [TColumnProp.Required], 'id')]
    Fpid: Proxy<Tperson>;
    function Getpid: Tperson;
    procedure Setpid(const Value: Tperson);
  public
    property id: Integer read Fid write Fid;
    property idhex: string read Fidhex write Fidhex;
    property swid: Integer read Fswid write Fswid;
    property date_created: Nullable<TDateTime> read Fdate_created write Fdate_created;
    property date_changed: Nullable<TDateTime> read Fdate_changed write Fdate_changed;
    property bibswid: Nullable<Integer> read Fbibswid write Fbibswid;
    property pid: Tperson read Getpid write Setpid;
  end;
  
  [Entity]
  [Table('codes')]
  [Id('Fid', TIdGenerator.IdentityOrSequence)]
  Tcode = class
  private
    [Column('id', [TColumnProp.Required, TColumnProp.NoInsert, TColumnProp.NoUpdate])]
    Fid: Integer;
    
    [Column('date_created', [])]
    Fdate_created: Nullable<TDateTime>;
    
    [Column('date_changed', [])]
    Fdate_changed: Nullable<TDateTime>;
    
    [Column('date_checked', [])]
    Fdate_checked: Nullable<TDateTime>;
    
    [Column('pass', [], 255)]
    Fpass: Nullable<string>;
    
    [Column('pass_freeradius', [], 255)]
    Fpass_freeradius: Nullable<string>;
    
    [Column('pass_ssha512', [], 255)]
    Fpass_ssha512: Nullable<string>;
    
    [Column('unsec', [], 255)]
    Funsec: Nullable<string>;
    
    [Column('date_temp', [])]
    Fdate_temp: Nullable<TDateTime>;
    
    [Column('date_lastchanged', [])]
    Fdate_lastchanged: Nullable<TDateTime>;
    
    [Association([TAssociationProp.Lazy, TAssociationProp.Required], CascadeTypeAll - [TCascadeType.Remove])]
    [JoinColumn('pid', [TColumnProp.Required], 'id')]
    Fpid: Proxy<Tperson>;
    function Getpid: Tperson;
    procedure Setpid(const Value: Tperson);
  public
    property id: Integer read Fid write Fid;
    property date_created: Nullable<TDateTime> read Fdate_created write Fdate_created;
    property date_changed: Nullable<TDateTime> read Fdate_changed write Fdate_changed;
    property date_checked: Nullable<TDateTime> read Fdate_checked write Fdate_checked;
    property pass: Nullable<string> read Fpass write Fpass;
    property pass_freeradius: Nullable<string> read Fpass_freeradius write Fpass_freeradius;
    property pass_ssha512: Nullable<string> read Fpass_ssha512 write Fpass_ssha512;
    property unsec: Nullable<string> read Funsec write Funsec;
    property date_temp: Nullable<TDateTime> read Fdate_temp write Fdate_temp;
    property date_lastchanged: Nullable<TDateTime> read Fdate_lastchanged write Fdate_lastchanged;
    property pid: Tperson read Getpid write Setpid;
  end;
  
  [Entity]
  [Table('persons')]
  [Id('Fid', TIdGenerator.IdentityOrSequence)]
  Tperson = class
  private
    [Column('id', [TColumnProp.Required, TColumnProp.NoInsert, TColumnProp.NoUpdate])]
    Fid: Integer;
    
    [Column('apid', [])]
    Fapid: Nullable<Integer>;
    
    [Column('date_created', [])]
    Fdate_created: Nullable<TDateTime>;
    
    [Column('date_changed', [])]
    Fdate_changed: Nullable<TDateTime>;
    
    [Column('date_checked', [])]
    Fdate_checked: Nullable<TDateTime>;
    
    [Column('user_created', [], 255)]
    Fuser_created: Nullable<string>;
    
    [Column('user_changed', [], 255)]
    Fuser_changed: Nullable<string>;
    
    [Column('lastname', [], 50)]
    Flastname: Nullable<string>;
    
    [Column('birthname', [], 50)]
    Fbirthname: Nullable<string>;
    
    [Column('firstname', [], 50)]
    Ffirstname: Nullable<string>;
    
    [Column('middlename', [], 50)]
    Fmiddlename: Nullable<string>;
    
    [Column('gender', [])]
    Fgender: Nullable<Integer>;
    
    [Column('birthdate', [])]
    Fbirthdate: Nullable<TDateTime>;
    
    [Column('mail', [], 255)]
    Fmail: Nullable<string>;
    
    [Column('email_ksh', [], 255)]
    Femail_ksh: Nullable<string>;
    
    [Column('login', [], 255)]
    Flogin: Nullable<string>;
    
    [Column('login_old', [], 255)]
    Flogin_old: Nullable<string>;
    
    [Column('login_new', [], 255)]
    Flogin_new: Nullable<string>;
    
    [Column('login_new_activated', [])]
    Flogin_new_activated: Nullable<TDateTime>;
    
    [Column('apid2', [], 255)]
    Fapid2: Nullable<string>;
    
    [Column('kpid2', [], 255)]
    Fkpid2: Nullable<string>;
    
    [Column('comment', [TColumnProp.Lazy])]
    [DBTypeMemo]
    Fcomment: TBlob;
    
    [Column('erledigt_alt', [])]
    Ferledigt_alt: Nullable<Integer>;
    
    [Column('polid', [])]
    Fpolid: Nullable<Integer>;
    
    [Column('cpid_old', [])]
    Fcpid_old: Nullable<Integer>;
    
    [Column('cpid2', [], 255)]
    Fcpid2: Nullable<string>;
    
    [Column('deactivated', [])]
    Fdeactivated: Nullable<Integer>;
    
    [Column('salutation', [], 255)]
    Fsalutation: Nullable<string>;
    
    [Column('mnr', [], 255)]
    Fmnr: Nullable<string>;
    
    [Column('birthcity', [], 255)]
    Fbirthcity: Nullable<string>;
    
    [Column('birthcountryid', [], 255)]
    Fbirthcountryid: Nullable<string>;
    
    [Column('birthcountry', [], 255)]
    Fbirthcountry: Nullable<string>;
    
    [Column('salutationletter', [], 255)]
    Fsalutationletter: Nullable<string>;
    
    [Column('salutationspecial', [TColumnProp.Lazy])]
    [DBTypeMemo]
    Fsalutationspecial: TBlob;
    
    [Column('titlepre', [], 255)]
    Ftitlepre: Nullable<string>;
    
    [Column('titlepost', [], 255)]
    Ftitlepost: Nullable<string>;
    
    [Column('title_academic', [], 255)]
    Ftitle_academic: Nullable<string>;
    
    [Column('title_job', [], 255)]
    Ftitle_job: Nullable<string>;
    
    [Column('company', [], 255)]
    Fcompany: Nullable<string>;
    
    [Column('position', [], 255)]
    Fposition: Nullable<string>;
    
    [Column('dead', [])]
    Fdead: Nullable<Integer>;
    
    [Column('date_of_death', [])]
    Fdate_of_death: Nullable<TDateTime>;
    
    [Column('pass2', [], 255)]
    Fpass2: Nullable<string>;
    
    [Column('parental', [])]
    Fparental: Nullable<Integer>;
    
    [Column('unsec2', [], 255)]
    Funsec2: Nullable<string>;
    
    [Column('date_temp2', [])]
    Fdate_temp2: Nullable<TDateTime>;
    
    [Column('date_neu', [])]
    Fdate_neu: Nullable<TDateTime>;
    
    [Column('citizenship1', [], 50)]
    Fcitizenship1: Nullable<string>;
    
    [Column('citizenship2', [], 50)]
    Fcitizenship2: Nullable<string>;
    
    [Column('adaid', [], 255)]
    Fadaid: Nullable<string>;
    
    [Column('mobilephone', [], 255)]
    Fmobilephone: Nullable<string>;
    
    [Column('emailsignature', [TColumnProp.Lazy])]
    [DBTypeMemo]
    Femailsignature: TBlob;
    
    [Column('roomlabel', [TColumnProp.Lazy])]
    [DBTypeMemo]
    Froomlabel: TBlob;
    
    [Column('lrzid', [], 255)]
    Flrzid: Nullable<string>;
    
    [Column('swcardid', [])]
    Fswcardid: Nullable<Integer>;
    
    [Column('roomnr', [], 255)]
    Froomnr: Nullable<string>;
    
    [Column('phonepin', [])]
    Fphonepin: Nullable<Integer>;
    
    [Column('function_internal', [], 255)]
    Ffunction_internal: Nullable<string>;
    
    [Column('phone_internal', [], 255)]
    Fphone_internal: Nullable<string>;
    
    [Column('qualification', [], 255)]
    Fqualification: Nullable<string>;
    
    [Column('url_extern', [], 255)]
    Furl_extern: Nullable<string>;
    
    [Column('moodleid', [])]
    Fmoodleid: Nullable<Integer>;
    
    [Column('hsadminid', [])]
    Fhsadminid: Nullable<Integer>;
    
    [Column('bibcode', [], 10)]
    Fbibcode: Nullable<string>;
    
    [Column('safeqid', [])]
    Fsafeqid: Nullable<Integer>;
    
    [Column('zoomid', [], 255)]
    Fzoomid: Nullable<string>;
    
    [ManyValuedAssociation([TAssociationProp.Lazy, TAssociationProp.Required], [TCascadeType.SaveUpdate, TCascadeType.Merge], 'Fpid')]
    Fcards: Proxy<TList<Tcard>>;
    
    [ManyValuedAssociation([TAssociationProp.Lazy, TAssociationProp.Required], [TCascadeType.SaveUpdate, TCascadeType.Merge], 'Fpid')]
    Fcodes: Proxy<TList<Tcode>>;
    
    [ManyValuedAssociation([TAssociationProp.Lazy, TAssociationProp.Required], [TCascadeType.SaveUpdate, TCascadeType.Merge], 'Fkpid')]
    Faddresses: Proxy<TList<Taddress>>;
    function Getcards: TList<Tcard>;
    function Getcodes: TList<Tcode>;
    function Getaddresses: TList<Taddress>;
  public
    constructor Create;
    destructor Destroy; override;
    property id: Integer read Fid write Fid;
    property apid: Nullable<Integer> read Fapid write Fapid;
    property date_created: Nullable<TDateTime> read Fdate_created write Fdate_created;
    property date_changed: Nullable<TDateTime> read Fdate_changed write Fdate_changed;
    property date_checked: Nullable<TDateTime> read Fdate_checked write Fdate_checked;
    property user_created: Nullable<string> read Fuser_created write Fuser_created;
    property user_changed: Nullable<string> read Fuser_changed write Fuser_changed;
    property lastname: Nullable<string> read Flastname write Flastname;
    property birthname: Nullable<string> read Fbirthname write Fbirthname;
    property firstname: Nullable<string> read Ffirstname write Ffirstname;
    property middlename: Nullable<string> read Fmiddlename write Fmiddlename;
    property gender: Nullable<Integer> read Fgender write Fgender;
    property birthdate: Nullable<TDateTime> read Fbirthdate write Fbirthdate;
    property mail: Nullable<string> read Fmail write Fmail;
    property email_ksh: Nullable<string> read Femail_ksh write Femail_ksh;
    property login: Nullable<string> read Flogin write Flogin;
    property login_old: Nullable<string> read Flogin_old write Flogin_old;
    property login_new: Nullable<string> read Flogin_new write Flogin_new;
    property login_new_activated: Nullable<TDateTime> read Flogin_new_activated write Flogin_new_activated;
    property apid2: Nullable<string> read Fapid2 write Fapid2;
    property kpid2: Nullable<string> read Fkpid2 write Fkpid2;
    property comment: TBlob read Fcomment write Fcomment;
    property erledigt_alt: Nullable<Integer> read Ferledigt_alt write Ferledigt_alt;
    property polid: Nullable<Integer> read Fpolid write Fpolid;
    property cpid_old: Nullable<Integer> read Fcpid_old write Fcpid_old;
    property cpid2: Nullable<string> read Fcpid2 write Fcpid2;
    property deactivated: Nullable<Integer> read Fdeactivated write Fdeactivated;
    property salutation: Nullable<string> read Fsalutation write Fsalutation;
    property mnr: Nullable<string> read Fmnr write Fmnr;
    property birthcity: Nullable<string> read Fbirthcity write Fbirthcity;
    property birthcountryid: Nullable<string> read Fbirthcountryid write Fbirthcountryid;
    property birthcountry: Nullable<string> read Fbirthcountry write Fbirthcountry;
    property salutationletter: Nullable<string> read Fsalutationletter write Fsalutationletter;
    property salutationspecial: TBlob read Fsalutationspecial write Fsalutationspecial;
    property titlepre: Nullable<string> read Ftitlepre write Ftitlepre;
    property titlepost: Nullable<string> read Ftitlepost write Ftitlepost;
    property title_academic: Nullable<string> read Ftitle_academic write Ftitle_academic;
    property title_job: Nullable<string> read Ftitle_job write Ftitle_job;
    property company: Nullable<string> read Fcompany write Fcompany;
    property position: Nullable<string> read Fposition write Fposition;
    property dead: Nullable<Integer> read Fdead write Fdead;
    property date_of_death: Nullable<TDateTime> read Fdate_of_death write Fdate_of_death;
    property pass2: Nullable<string> read Fpass2 write Fpass2;
    property parental: Nullable<Integer> read Fparental write Fparental;
    property unsec2: Nullable<string> read Funsec2 write Funsec2;
    property date_temp2: Nullable<TDateTime> read Fdate_temp2 write Fdate_temp2;
    property date_neu: Nullable<TDateTime> read Fdate_neu write Fdate_neu;
    property citizenship1: Nullable<string> read Fcitizenship1 write Fcitizenship1;
    property citizenship2: Nullable<string> read Fcitizenship2 write Fcitizenship2;
    property adaid: Nullable<string> read Fadaid write Fadaid;
    property mobilephone: Nullable<string> read Fmobilephone write Fmobilephone;
    property emailsignature: TBlob read Femailsignature write Femailsignature;
    property roomlabel: TBlob read Froomlabel write Froomlabel;
    property lrzid: Nullable<string> read Flrzid write Flrzid;
    property swcardid: Nullable<Integer> read Fswcardid write Fswcardid;
    property roomnr: Nullable<string> read Froomnr write Froomnr;
    property phonepin: Nullable<Integer> read Fphonepin write Fphonepin;
    property function_internal: Nullable<string> read Ffunction_internal write Ffunction_internal;
    property phone_internal: Nullable<string> read Fphone_internal write Fphone_internal;
    property qualification: Nullable<string> read Fqualification write Fqualification;
    property url_extern: Nullable<string> read Furl_extern write Furl_extern;
    property moodleid: Nullable<Integer> read Fmoodleid write Fmoodleid;
    property hsadminid: Nullable<Integer> read Fhsadminid write Fhsadminid;
    property bibcode: Nullable<string> read Fbibcode write Fbibcode;
    property safeqid: Nullable<Integer> read Fsafeqid write Fsafeqid;
    property zoomid: Nullable<string> read Fzoomid write Fzoomid;
    property cards: TList<Tcard> read Getcards;
    property codes: TList<Tcode> read Getcodes;
    property addresses: TList<Taddress> read Getaddresses;
  end;
  
  IaddressDictionary = interface;
  
  IcardDictionary = interface;
  
  IcodeDictionary = interface;
  
  IpersonDictionary = interface;
  
  IaddressDictionary = interface(IAureliusEntityDictionary)
    function cpid_old2: TLinqProjection;
    function date_created: TLinqProjection;
    function date_changed: TLinqProjection;
    function user_created: TLinqProjection;
    function user_changed: TLinqProjection;
    function email: TLinqProjection;
    function emailprivate: TLinqProjection;
    function tel: TLinqProjection;
    function telprivate: TLinqProjection;
    function mobil: TLinqProjection;
    function mobilprivate: TLinqProjection;
    function company1: TLinqProjection;
    function additional1: TLinqProjection;
    function street1: TLinqProjection;
    function zipcode1: TLinqProjection;
    function city1: TLinqProjection;
    function country1: TLinqProjection;
    function company2: TLinqProjection;
    function additional2: TLinqProjection;
    function street2: TLinqProjection;
    function zipcode2: TLinqProjection;
    function city2: TLinqProjection;
    function country2: TLinqProjection;
    function coveraddress: TLinqProjection;
    function comment: TLinqProjection;
    function new: TLinqProjection;
    function kpid: IpersonDictionary;
  end;
  
  IcardDictionary = interface(IAureliusEntityDictionary)
    function id: TLinqProjection;
    function idhex: TLinqProjection;
    function swid: TLinqProjection;
    function date_created: TLinqProjection;
    function date_changed: TLinqProjection;
    function bibswid: TLinqProjection;
    function pid: IpersonDictionary;
  end;
  
  IcodeDictionary = interface(IAureliusEntityDictionary)
    function id: TLinqProjection;
    function date_created: TLinqProjection;
    function date_changed: TLinqProjection;
    function date_checked: TLinqProjection;
    function pass: TLinqProjection;
    function pass_freeradius: TLinqProjection;
    function pass_ssha512: TLinqProjection;
    function unsec: TLinqProjection;
    function date_temp: TLinqProjection;
    function date_lastchanged: TLinqProjection;
    function pid: IpersonDictionary;
  end;
  
  IpersonDictionary = interface(IAureliusEntityDictionary)
    function id: TLinqProjection;
    function apid: TLinqProjection;
    function date_created: TLinqProjection;
    function date_changed: TLinqProjection;
    function date_checked: TLinqProjection;
    function user_created: TLinqProjection;
    function user_changed: TLinqProjection;
    function lastname: TLinqProjection;
    function birthname: TLinqProjection;
    function firstname: TLinqProjection;
    function middlename: TLinqProjection;
    function gender: TLinqProjection;
    function birthdate: TLinqProjection;
    function mail: TLinqProjection;
    function email_ksh: TLinqProjection;
    function login: TLinqProjection;
    function login_old: TLinqProjection;
    function login_new: TLinqProjection;
    function login_new_activated: TLinqProjection;
    function apid2: TLinqProjection;
    function kpid2: TLinqProjection;
    function comment: TLinqProjection;
    function erledigt_alt: TLinqProjection;
    function polid: TLinqProjection;
    function cpid_old: TLinqProjection;
    function cpid2: TLinqProjection;
    function deactivated: TLinqProjection;
    function salutation: TLinqProjection;
    function mnr: TLinqProjection;
    function birthcity: TLinqProjection;
    function birthcountryid: TLinqProjection;
    function birthcountry: TLinqProjection;
    function salutationletter: TLinqProjection;
    function salutationspecial: TLinqProjection;
    function titlepre: TLinqProjection;
    function titlepost: TLinqProjection;
    function title_academic: TLinqProjection;
    function title_job: TLinqProjection;
    function company: TLinqProjection;
    function position: TLinqProjection;
    function dead: TLinqProjection;
    function date_of_death: TLinqProjection;
    function pass2: TLinqProjection;
    function parental: TLinqProjection;
    function unsec2: TLinqProjection;
    function date_temp2: TLinqProjection;
    function date_neu: TLinqProjection;
    function citizenship1: TLinqProjection;
    function citizenship2: TLinqProjection;
    function adaid: TLinqProjection;
    function mobilephone: TLinqProjection;
    function emailsignature: TLinqProjection;
    function roomlabel: TLinqProjection;
    function lrzid: TLinqProjection;
    function swcardid: TLinqProjection;
    function roomnr: TLinqProjection;
    function phonepin: TLinqProjection;
    function function_internal: TLinqProjection;
    function phone_internal: TLinqProjection;
    function qualification: TLinqProjection;
    function url_extern: TLinqProjection;
    function moodleid: TLinqProjection;
    function hsadminid: TLinqProjection;
    function bibcode: TLinqProjection;
    function safeqid: TLinqProjection;
    function zoomid: TLinqProjection;
  end;
  
  TaddressDictionary = class(TAureliusEntityDictionary, IaddressDictionary)
  public
    function cpid_old2: TLinqProjection;
    function date_created: TLinqProjection;
    function date_changed: TLinqProjection;
    function user_created: TLinqProjection;
    function user_changed: TLinqProjection;
    function email: TLinqProjection;
    function emailprivate: TLinqProjection;
    function tel: TLinqProjection;
    function telprivate: TLinqProjection;
    function mobil: TLinqProjection;
    function mobilprivate: TLinqProjection;
    function company1: TLinqProjection;
    function additional1: TLinqProjection;
    function street1: TLinqProjection;
    function zipcode1: TLinqProjection;
    function city1: TLinqProjection;
    function country1: TLinqProjection;
    function company2: TLinqProjection;
    function additional2: TLinqProjection;
    function street2: TLinqProjection;
    function zipcode2: TLinqProjection;
    function city2: TLinqProjection;
    function country2: TLinqProjection;
    function coveraddress: TLinqProjection;
    function comment: TLinqProjection;
    function new: TLinqProjection;
    function kpid: IpersonDictionary;
  end;
  
  TcardDictionary = class(TAureliusEntityDictionary, IcardDictionary)
  public
    function id: TLinqProjection;
    function idhex: TLinqProjection;
    function swid: TLinqProjection;
    function date_created: TLinqProjection;
    function date_changed: TLinqProjection;
    function bibswid: TLinqProjection;
    function pid: IpersonDictionary;
  end;
  
  TcodeDictionary = class(TAureliusEntityDictionary, IcodeDictionary)
  public
    function id: TLinqProjection;
    function date_created: TLinqProjection;
    function date_changed: TLinqProjection;
    function date_checked: TLinqProjection;
    function pass: TLinqProjection;
    function pass_freeradius: TLinqProjection;
    function pass_ssha512: TLinqProjection;
    function unsec: TLinqProjection;
    function date_temp: TLinqProjection;
    function date_lastchanged: TLinqProjection;
    function pid: IpersonDictionary;
  end;
  
  TpersonDictionary = class(TAureliusEntityDictionary, IpersonDictionary)
  public
    function id: TLinqProjection;
    function apid: TLinqProjection;
    function date_created: TLinqProjection;
    function date_changed: TLinqProjection;
    function date_checked: TLinqProjection;
    function user_created: TLinqProjection;
    function user_changed: TLinqProjection;
    function lastname: TLinqProjection;
    function birthname: TLinqProjection;
    function firstname: TLinqProjection;
    function middlename: TLinqProjection;
    function gender: TLinqProjection;
    function birthdate: TLinqProjection;
    function mail: TLinqProjection;
    function email_ksh: TLinqProjection;
    function login: TLinqProjection;
    function login_old: TLinqProjection;
    function login_new: TLinqProjection;
    function login_new_activated: TLinqProjection;
    function apid2: TLinqProjection;
    function kpid2: TLinqProjection;
    function comment: TLinqProjection;
    function erledigt_alt: TLinqProjection;
    function polid: TLinqProjection;
    function cpid_old: TLinqProjection;
    function cpid2: TLinqProjection;
    function deactivated: TLinqProjection;
    function salutation: TLinqProjection;
    function mnr: TLinqProjection;
    function birthcity: TLinqProjection;
    function birthcountryid: TLinqProjection;
    function birthcountry: TLinqProjection;
    function salutationletter: TLinqProjection;
    function salutationspecial: TLinqProjection;
    function titlepre: TLinqProjection;
    function titlepost: TLinqProjection;
    function title_academic: TLinqProjection;
    function title_job: TLinqProjection;
    function company: TLinqProjection;
    function position: TLinqProjection;
    function dead: TLinqProjection;
    function date_of_death: TLinqProjection;
    function pass2: TLinqProjection;
    function parental: TLinqProjection;
    function unsec2: TLinqProjection;
    function date_temp2: TLinqProjection;
    function date_neu: TLinqProjection;
    function citizenship1: TLinqProjection;
    function citizenship2: TLinqProjection;
    function adaid: TLinqProjection;
    function mobilephone: TLinqProjection;
    function emailsignature: TLinqProjection;
    function roomlabel: TLinqProjection;
    function lrzid: TLinqProjection;
    function swcardid: TLinqProjection;
    function roomnr: TLinqProjection;
    function phonepin: TLinqProjection;
    function function_internal: TLinqProjection;
    function phone_internal: TLinqProjection;
    function qualification: TLinqProjection;
    function url_extern: TLinqProjection;
    function moodleid: TLinqProjection;
    function hsadminid: TLinqProjection;
    function bibcode: TLinqProjection;
    function safeqid: TLinqProjection;
    function zoomid: TLinqProjection;
  end;
  
  IDictionary = interface(IAureliusDictionary)
    function address: IaddressDictionary;
    function card: IcardDictionary;
    function code: IcodeDictionary;
    function person: IpersonDictionary;
  end;
  
  TDictionary = class(TAureliusDictionary, IDictionary)
  public
    function address: IaddressDictionary;
    function card: IcardDictionary;
    function code: IcodeDictionary;
    function person: IpersonDictionary;
  end;
  
function Dic: IDictionary;

implementation

var
  __Dic: IDictionary;

function Dic: IDictionary;
begin
  if __Dic = nil then __Dic := TDictionary.Create;
  result := __Dic;
end;

{ Taddress }

function Taddress.Getkpid: Tperson;
begin
  result := Fkpid.Value;
end;

procedure Taddress.Setkpid(const Value: Tperson);
begin
  Fkpid.Value := Value;
end;

{ Tcard }

function Tcard.Getpid: Tperson;
begin
  result := Fpid.Value;
end;

procedure Tcard.Setpid(const Value: Tperson);
begin
  Fpid.Value := Value;
end;

{ Tcode }

function Tcode.Getpid: Tperson;
begin
  result := Fpid.Value;
end;

procedure Tcode.Setpid(const Value: Tperson);
begin
  Fpid.Value := Value;
end;

{ Tperson }

constructor Tperson.Create;
begin
  inherited;
  Fcards.SetInitialValue(TList<Tcard>.Create);
  Fcodes.SetInitialValue(TList<Tcode>.Create);
  Faddresses.SetInitialValue(TList<Taddress>.Create);
end;

destructor Tperson.Destroy;
begin
  Faddresses.DestroyValue;
  Fcodes.DestroyValue;
  Fcards.DestroyValue;
  inherited;
end;

function Tperson.Getcards: TList<Tcard>;
begin
  result := Fcards.Value;
end;

function Tperson.Getcodes: TList<Tcode>;
begin
  result := Fcodes.Value;
end;

function Tperson.Getaddresses: TList<Taddress>;
begin
  result := Faddresses.Value;
end;

{ TaddressDictionary }

function TaddressDictionary.cpid_old2: TLinqProjection;
begin
  Result := Prop('cpid_old2');
end;

function TaddressDictionary.date_created: TLinqProjection;
begin
  Result := Prop('date_created');
end;

function TaddressDictionary.date_changed: TLinqProjection;
begin
  Result := Prop('date_changed');
end;

function TaddressDictionary.user_created: TLinqProjection;
begin
  Result := Prop('user_created');
end;

function TaddressDictionary.user_changed: TLinqProjection;
begin
  Result := Prop('user_changed');
end;

function TaddressDictionary.email: TLinqProjection;
begin
  Result := Prop('email');
end;

function TaddressDictionary.emailprivate: TLinqProjection;
begin
  Result := Prop('emailprivate');
end;

function TaddressDictionary.tel: TLinqProjection;
begin
  Result := Prop('tel');
end;

function TaddressDictionary.telprivate: TLinqProjection;
begin
  Result := Prop('telprivate');
end;

function TaddressDictionary.mobil: TLinqProjection;
begin
  Result := Prop('mobil');
end;

function TaddressDictionary.mobilprivate: TLinqProjection;
begin
  Result := Prop('mobilprivate');
end;

function TaddressDictionary.company1: TLinqProjection;
begin
  Result := Prop('company1');
end;

function TaddressDictionary.additional1: TLinqProjection;
begin
  Result := Prop('additional1');
end;

function TaddressDictionary.street1: TLinqProjection;
begin
  Result := Prop('street1');
end;

function TaddressDictionary.zipcode1: TLinqProjection;
begin
  Result := Prop('zipcode1');
end;

function TaddressDictionary.city1: TLinqProjection;
begin
  Result := Prop('city1');
end;

function TaddressDictionary.country1: TLinqProjection;
begin
  Result := Prop('country1');
end;

function TaddressDictionary.company2: TLinqProjection;
begin
  Result := Prop('company2');
end;

function TaddressDictionary.additional2: TLinqProjection;
begin
  Result := Prop('additional2');
end;

function TaddressDictionary.street2: TLinqProjection;
begin
  Result := Prop('street2');
end;

function TaddressDictionary.zipcode2: TLinqProjection;
begin
  Result := Prop('zipcode2');
end;

function TaddressDictionary.city2: TLinqProjection;
begin
  Result := Prop('city2');
end;

function TaddressDictionary.country2: TLinqProjection;
begin
  Result := Prop('country2');
end;

function TaddressDictionary.coveraddress: TLinqProjection;
begin
  Result := Prop('coveraddress');
end;

function TaddressDictionary.comment: TLinqProjection;
begin
  Result := Prop('comment');
end;

function TaddressDictionary.new: TLinqProjection;
begin
  Result := Prop('new');
end;

function TaddressDictionary.kpid: IpersonDictionary;
begin
  Result := TpersonDictionary.Create(PropName('kpid'));
end;

{ TcardDictionary }

function TcardDictionary.id: TLinqProjection;
begin
  Result := Prop('id');
end;

function TcardDictionary.idhex: TLinqProjection;
begin
  Result := Prop('idhex');
end;

function TcardDictionary.swid: TLinqProjection;
begin
  Result := Prop('swid');
end;

function TcardDictionary.date_created: TLinqProjection;
begin
  Result := Prop('date_created');
end;

function TcardDictionary.date_changed: TLinqProjection;
begin
  Result := Prop('date_changed');
end;

function TcardDictionary.bibswid: TLinqProjection;
begin
  Result := Prop('bibswid');
end;

function TcardDictionary.pid: IpersonDictionary;
begin
  Result := TpersonDictionary.Create(PropName('pid'));
end;

{ TcodeDictionary }

function TcodeDictionary.id: TLinqProjection;
begin
  Result := Prop('id');
end;

function TcodeDictionary.date_created: TLinqProjection;
begin
  Result := Prop('date_created');
end;

function TcodeDictionary.date_changed: TLinqProjection;
begin
  Result := Prop('date_changed');
end;

function TcodeDictionary.date_checked: TLinqProjection;
begin
  Result := Prop('date_checked');
end;

function TcodeDictionary.pass: TLinqProjection;
begin
  Result := Prop('pass');
end;

function TcodeDictionary.pass_freeradius: TLinqProjection;
begin
  Result := Prop('pass_freeradius');
end;

function TcodeDictionary.pass_ssha512: TLinqProjection;
begin
  Result := Prop('pass_ssha512');
end;

function TcodeDictionary.unsec: TLinqProjection;
begin
  Result := Prop('unsec');
end;

function TcodeDictionary.date_temp: TLinqProjection;
begin
  Result := Prop('date_temp');
end;

function TcodeDictionary.date_lastchanged: TLinqProjection;
begin
  Result := Prop('date_lastchanged');
end;

function TcodeDictionary.pid: IpersonDictionary;
begin
  Result := TpersonDictionary.Create(PropName('pid'));
end;

{ TpersonDictionary }

function TpersonDictionary.id: TLinqProjection;
begin
  Result := Prop('id');
end;

function TpersonDictionary.apid: TLinqProjection;
begin
  Result := Prop('apid');
end;

function TpersonDictionary.date_created: TLinqProjection;
begin
  Result := Prop('date_created');
end;

function TpersonDictionary.date_changed: TLinqProjection;
begin
  Result := Prop('date_changed');
end;

function TpersonDictionary.date_checked: TLinqProjection;
begin
  Result := Prop('date_checked');
end;

function TpersonDictionary.user_created: TLinqProjection;
begin
  Result := Prop('user_created');
end;

function TpersonDictionary.user_changed: TLinqProjection;
begin
  Result := Prop('user_changed');
end;

function TpersonDictionary.lastname: TLinqProjection;
begin
  Result := Prop('lastname');
end;

function TpersonDictionary.birthname: TLinqProjection;
begin
  Result := Prop('birthname');
end;

function TpersonDictionary.firstname: TLinqProjection;
begin
  Result := Prop('firstname');
end;

function TpersonDictionary.middlename: TLinqProjection;
begin
  Result := Prop('middlename');
end;

function TpersonDictionary.gender: TLinqProjection;
begin
  Result := Prop('gender');
end;

function TpersonDictionary.birthdate: TLinqProjection;
begin
  Result := Prop('birthdate');
end;

function TpersonDictionary.mail: TLinqProjection;
begin
  Result := Prop('mail');
end;

function TpersonDictionary.email_ksh: TLinqProjection;
begin
  Result := Prop('email_ksh');
end;

function TpersonDictionary.login: TLinqProjection;
begin
  Result := Prop('login');
end;

function TpersonDictionary.login_old: TLinqProjection;
begin
  Result := Prop('login_old');
end;

function TpersonDictionary.login_new: TLinqProjection;
begin
  Result := Prop('login_new');
end;

function TpersonDictionary.login_new_activated: TLinqProjection;
begin
  Result := Prop('login_new_activated');
end;

function TpersonDictionary.apid2: TLinqProjection;
begin
  Result := Prop('apid2');
end;

function TpersonDictionary.kpid2: TLinqProjection;
begin
  Result := Prop('kpid2');
end;

function TpersonDictionary.comment: TLinqProjection;
begin
  Result := Prop('comment');
end;

function TpersonDictionary.erledigt_alt: TLinqProjection;
begin
  Result := Prop('erledigt_alt');
end;

function TpersonDictionary.polid: TLinqProjection;
begin
  Result := Prop('polid');
end;

function TpersonDictionary.cpid_old: TLinqProjection;
begin
  Result := Prop('cpid_old');
end;

function TpersonDictionary.cpid2: TLinqProjection;
begin
  Result := Prop('cpid2');
end;

function TpersonDictionary.deactivated: TLinqProjection;
begin
  Result := Prop('deactivated');
end;

function TpersonDictionary.salutation: TLinqProjection;
begin
  Result := Prop('salutation');
end;

function TpersonDictionary.mnr: TLinqProjection;
begin
  Result := Prop('mnr');
end;

function TpersonDictionary.birthcity: TLinqProjection;
begin
  Result := Prop('birthcity');
end;

function TpersonDictionary.birthcountryid: TLinqProjection;
begin
  Result := Prop('birthcountryid');
end;

function TpersonDictionary.birthcountry: TLinqProjection;
begin
  Result := Prop('birthcountry');
end;

function TpersonDictionary.salutationletter: TLinqProjection;
begin
  Result := Prop('salutationletter');
end;

function TpersonDictionary.salutationspecial: TLinqProjection;
begin
  Result := Prop('salutationspecial');
end;

function TpersonDictionary.titlepre: TLinqProjection;
begin
  Result := Prop('titlepre');
end;

function TpersonDictionary.titlepost: TLinqProjection;
begin
  Result := Prop('titlepost');
end;

function TpersonDictionary.title_academic: TLinqProjection;
begin
  Result := Prop('title_academic');
end;

function TpersonDictionary.title_job: TLinqProjection;
begin
  Result := Prop('title_job');
end;

function TpersonDictionary.company: TLinqProjection;
begin
  Result := Prop('company');
end;

function TpersonDictionary.position: TLinqProjection;
begin
  Result := Prop('position');
end;

function TpersonDictionary.dead: TLinqProjection;
begin
  Result := Prop('dead');
end;

function TpersonDictionary.date_of_death: TLinqProjection;
begin
  Result := Prop('date_of_death');
end;

function TpersonDictionary.pass2: TLinqProjection;
begin
  Result := Prop('pass2');
end;

function TpersonDictionary.parental: TLinqProjection;
begin
  Result := Prop('parental');
end;

function TpersonDictionary.unsec2: TLinqProjection;
begin
  Result := Prop('unsec2');
end;

function TpersonDictionary.date_temp2: TLinqProjection;
begin
  Result := Prop('date_temp2');
end;

function TpersonDictionary.date_neu: TLinqProjection;
begin
  Result := Prop('date_neu');
end;

function TpersonDictionary.citizenship1: TLinqProjection;
begin
  Result := Prop('citizenship1');
end;

function TpersonDictionary.citizenship2: TLinqProjection;
begin
  Result := Prop('citizenship2');
end;

function TpersonDictionary.adaid: TLinqProjection;
begin
  Result := Prop('adaid');
end;

function TpersonDictionary.mobilephone: TLinqProjection;
begin
  Result := Prop('mobilephone');
end;

function TpersonDictionary.emailsignature: TLinqProjection;
begin
  Result := Prop('emailsignature');
end;

function TpersonDictionary.roomlabel: TLinqProjection;
begin
  Result := Prop('roomlabel');
end;

function TpersonDictionary.lrzid: TLinqProjection;
begin
  Result := Prop('lrzid');
end;

function TpersonDictionary.swcardid: TLinqProjection;
begin
  Result := Prop('swcardid');
end;

function TpersonDictionary.roomnr: TLinqProjection;
begin
  Result := Prop('roomnr');
end;

function TpersonDictionary.phonepin: TLinqProjection;
begin
  Result := Prop('phonepin');
end;

function TpersonDictionary.function_internal: TLinqProjection;
begin
  Result := Prop('function_internal');
end;

function TpersonDictionary.phone_internal: TLinqProjection;
begin
  Result := Prop('phone_internal');
end;

function TpersonDictionary.qualification: TLinqProjection;
begin
  Result := Prop('qualification');
end;

function TpersonDictionary.url_extern: TLinqProjection;
begin
  Result := Prop('url_extern');
end;

function TpersonDictionary.moodleid: TLinqProjection;
begin
  Result := Prop('moodleid');
end;

function TpersonDictionary.hsadminid: TLinqProjection;
begin
  Result := Prop('hsadminid');
end;

function TpersonDictionary.bibcode: TLinqProjection;
begin
  Result := Prop('bibcode');
end;

function TpersonDictionary.safeqid: TLinqProjection;
begin
  Result := Prop('safeqid');
end;

function TpersonDictionary.zoomid: TLinqProjection;
begin
  Result := Prop('zoomid');
end;

{ TDictionary }

function TDictionary.address: IaddressDictionary;
begin
  Result := TaddressDictionary.Create;
end;

function TDictionary.card: IcardDictionary;
begin
  Result := TcardDictionary.Create;
end;

function TDictionary.code: IcodeDictionary;
begin
  Result := TcodeDictionary.Create;
end;

function TDictionary.person: IpersonDictionary;
begin
  Result := TpersonDictionary.Create;
end;

initialization
  RegisterEntity(Taddress);
  RegisterEntity(Tcard);
  RegisterEntity(Tcode);
  RegisterEntity(Tperson);

end.
