unit testaurelius2;

interface

uses
  Aurelius.Dictionary.Classes, 
  Aurelius.Linq;

type
  TaddressDictionary = class;
  TcardDictionary = class;
  TcodeDictionary = class;
  TpersonDictionary = class;
  
  IaddressDictionary = interface;
  
  IcardDictionary = interface;
  
  IcodeDictionary = interface;
  
  IpersonDictionary = interface;
  
  IaddressDictionary = interface(IAureliusEntityDictionary)
    function Fcpid_old2: TLinqProjection;
    function Fdate_created: TLinqProjection;
    function Fdate_changed: TLinqProjection;
    function Fuser_created: TLinqProjection;
    function Fuser_changed: TLinqProjection;
    function Femail: TLinqProjection;
    function Femailprivate: TLinqProjection;
    function Ftel: TLinqProjection;
    function Ftelprivate: TLinqProjection;
    function Fmobil: TLinqProjection;
    function Fmobilprivate: TLinqProjection;
    function Fcompany1: TLinqProjection;
    function Fadditional1: TLinqProjection;
    function Fstreet1: TLinqProjection;
    function Fzipcode1: TLinqProjection;
    function Fcity1: TLinqProjection;
    function Fcountry1: TLinqProjection;
    function Fcompany2: TLinqProjection;
    function Fadditional2: TLinqProjection;
    function Fstreet2: TLinqProjection;
    function Fzipcode2: TLinqProjection;
    function Fcity2: TLinqProjection;
    function Fcountry2: TLinqProjection;
    function Fcoveraddress: TLinqProjection;
    function Fcomment: TLinqProjection;
    function Fnew: TLinqProjection;
    function Fkpid: IpersonDictionary;
  end;
  
  IcardDictionary = interface(IAureliusEntityDictionary)
    function Fid: TLinqProjection;
    function Fidhex: TLinqProjection;
    function Fswid: TLinqProjection;
    function Fdate_created: TLinqProjection;
    function Fdate_changed: TLinqProjection;
    function Fbibswid: TLinqProjection;
    function Fpid: IpersonDictionary;
  end;
  
  IcodeDictionary = interface(IAureliusEntityDictionary)
    function Fid: TLinqProjection;
    function Fdate_created: TLinqProjection;
    function Fdate_changed: TLinqProjection;
    function Fdate_checked: TLinqProjection;
    function Fpass: TLinqProjection;
    function Fpass_freeradius: TLinqProjection;
    function Fpass_ssha512: TLinqProjection;
    function Funsec: TLinqProjection;
    function Fdate_temp: TLinqProjection;
    function Fdate_lastchanged: TLinqProjection;
    function Fpid: IpersonDictionary;
  end;
  
  IpersonDictionary = interface(IAureliusEntityDictionary)
    function Fid: TLinqProjection;
    function Fapid: TLinqProjection;
    function Fdate_created: TLinqProjection;
    function Fdate_changed: TLinqProjection;
    function Fdate_checked: TLinqProjection;
    function Fuser_created: TLinqProjection;
    function Fuser_changed: TLinqProjection;
    function Flastname: TLinqProjection;
    function Fbirthname: TLinqProjection;
    function Ffirstname: TLinqProjection;
    function Fmiddlename: TLinqProjection;
    function Fgender: TLinqProjection;
    function Fbirthdate: TLinqProjection;
    function Fmail: TLinqProjection;
    function Femail_ksh: TLinqProjection;
    function Flogin: TLinqProjection;
    function Flogin_old: TLinqProjection;
    function Flogin_new: TLinqProjection;
    function Flogin_new_activated: TLinqProjection;
    function Fapid2: TLinqProjection;
    function Fkpid2: TLinqProjection;
    function Fcomment: TLinqProjection;
    function Ferledigt_alt: TLinqProjection;
    function Fpolid: TLinqProjection;
    function Fcpid_old: TLinqProjection;
    function Fcpid2: TLinqProjection;
    function Fdeactivated: TLinqProjection;
    function Fsalutation: TLinqProjection;
    function Fmnr: TLinqProjection;
    function Fbirthcity: TLinqProjection;
    function Fbirthcountryid: TLinqProjection;
    function Fbirthcountry: TLinqProjection;
    function Fsalutationletter: TLinqProjection;
    function Fsalutationspecial: TLinqProjection;
    function Ftitlepre: TLinqProjection;
    function Ftitlepost: TLinqProjection;
    function Ftitle_academic: TLinqProjection;
    function Ftitle_job: TLinqProjection;
    function Fcompany: TLinqProjection;
    function Fposition: TLinqProjection;
    function Fdead: TLinqProjection;
    function Fdate_of_death: TLinqProjection;
    function Fpass2: TLinqProjection;
    function Fparental: TLinqProjection;
    function Funsec2: TLinqProjection;
    function Fdate_temp2: TLinqProjection;
    function Fdate_neu: TLinqProjection;
    function Fcitizenship1: TLinqProjection;
    function Fcitizenship2: TLinqProjection;
    function Fadaid: TLinqProjection;
    function Fmobilephone: TLinqProjection;
    function Femailsignature: TLinqProjection;
    function Froomlabel: TLinqProjection;
    function Flrzid: TLinqProjection;
    function Fswcardid: TLinqProjection;
    function Froomnr: TLinqProjection;
    function Fphonepin: TLinqProjection;
    function Ffunction_internal: TLinqProjection;
    function Fphone_internal: TLinqProjection;
    function Fqualification: TLinqProjection;
    function Furl_extern: TLinqProjection;
    function Fmoodleid: TLinqProjection;
    function Fhsadminid: TLinqProjection;
    function Fbibcode: TLinqProjection;
    function Fsafeqid: TLinqProjection;
    function Fzoomid: TLinqProjection;
    function Fcards: IcardDictionary;
    function Fcodes: IcodeDictionary;
    function Faddresses: IaddressDictionary;
  end;
  
  TaddressDictionary = class(TAureliusEntityDictionary, IaddressDictionary)
  public
    function Fcpid_old2: TLinqProjection;
    function Fdate_created: TLinqProjection;
    function Fdate_changed: TLinqProjection;
    function Fuser_created: TLinqProjection;
    function Fuser_changed: TLinqProjection;
    function Femail: TLinqProjection;
    function Femailprivate: TLinqProjection;
    function Ftel: TLinqProjection;
    function Ftelprivate: TLinqProjection;
    function Fmobil: TLinqProjection;
    function Fmobilprivate: TLinqProjection;
    function Fcompany1: TLinqProjection;
    function Fadditional1: TLinqProjection;
    function Fstreet1: TLinqProjection;
    function Fzipcode1: TLinqProjection;
    function Fcity1: TLinqProjection;
    function Fcountry1: TLinqProjection;
    function Fcompany2: TLinqProjection;
    function Fadditional2: TLinqProjection;
    function Fstreet2: TLinqProjection;
    function Fzipcode2: TLinqProjection;
    function Fcity2: TLinqProjection;
    function Fcountry2: TLinqProjection;
    function Fcoveraddress: TLinqProjection;
    function Fcomment: TLinqProjection;
    function Fnew: TLinqProjection;
    function Fkpid: IpersonDictionary;
  end;
  
  TcardDictionary = class(TAureliusEntityDictionary, IcardDictionary)
  public
    function Fid: TLinqProjection;
    function Fidhex: TLinqProjection;
    function Fswid: TLinqProjection;
    function Fdate_created: TLinqProjection;
    function Fdate_changed: TLinqProjection;
    function Fbibswid: TLinqProjection;
    function Fpid: IpersonDictionary;
  end;
  
  TcodeDictionary = class(TAureliusEntityDictionary, IcodeDictionary)
  public
    function Fid: TLinqProjection;
    function Fdate_created: TLinqProjection;
    function Fdate_changed: TLinqProjection;
    function Fdate_checked: TLinqProjection;
    function Fpass: TLinqProjection;
    function Fpass_freeradius: TLinqProjection;
    function Fpass_ssha512: TLinqProjection;
    function Funsec: TLinqProjection;
    function Fdate_temp: TLinqProjection;
    function Fdate_lastchanged: TLinqProjection;
    function Fpid: IpersonDictionary;
  end;
  
  TpersonDictionary = class(TAureliusEntityDictionary, IpersonDictionary)
  public
    function Fid: TLinqProjection;
    function Fapid: TLinqProjection;
    function Fdate_created: TLinqProjection;
    function Fdate_changed: TLinqProjection;
    function Fdate_checked: TLinqProjection;
    function Fuser_created: TLinqProjection;
    function Fuser_changed: TLinqProjection;
    function Flastname: TLinqProjection;
    function Fbirthname: TLinqProjection;
    function Ffirstname: TLinqProjection;
    function Fmiddlename: TLinqProjection;
    function Fgender: TLinqProjection;
    function Fbirthdate: TLinqProjection;
    function Fmail: TLinqProjection;
    function Femail_ksh: TLinqProjection;
    function Flogin: TLinqProjection;
    function Flogin_old: TLinqProjection;
    function Flogin_new: TLinqProjection;
    function Flogin_new_activated: TLinqProjection;
    function Fapid2: TLinqProjection;
    function Fkpid2: TLinqProjection;
    function Fcomment: TLinqProjection;
    function Ferledigt_alt: TLinqProjection;
    function Fpolid: TLinqProjection;
    function Fcpid_old: TLinqProjection;
    function Fcpid2: TLinqProjection;
    function Fdeactivated: TLinqProjection;
    function Fsalutation: TLinqProjection;
    function Fmnr: TLinqProjection;
    function Fbirthcity: TLinqProjection;
    function Fbirthcountryid: TLinqProjection;
    function Fbirthcountry: TLinqProjection;
    function Fsalutationletter: TLinqProjection;
    function Fsalutationspecial: TLinqProjection;
    function Ftitlepre: TLinqProjection;
    function Ftitlepost: TLinqProjection;
    function Ftitle_academic: TLinqProjection;
    function Ftitle_job: TLinqProjection;
    function Fcompany: TLinqProjection;
    function Fposition: TLinqProjection;
    function Fdead: TLinqProjection;
    function Fdate_of_death: TLinqProjection;
    function Fpass2: TLinqProjection;
    function Fparental: TLinqProjection;
    function Funsec2: TLinqProjection;
    function Fdate_temp2: TLinqProjection;
    function Fdate_neu: TLinqProjection;
    function Fcitizenship1: TLinqProjection;
    function Fcitizenship2: TLinqProjection;
    function Fadaid: TLinqProjection;
    function Fmobilephone: TLinqProjection;
    function Femailsignature: TLinqProjection;
    function Froomlabel: TLinqProjection;
    function Flrzid: TLinqProjection;
    function Fswcardid: TLinqProjection;
    function Froomnr: TLinqProjection;
    function Fphonepin: TLinqProjection;
    function Ffunction_internal: TLinqProjection;
    function Fphone_internal: TLinqProjection;
    function Fqualification: TLinqProjection;
    function Furl_extern: TLinqProjection;
    function Fmoodleid: TLinqProjection;
    function Fhsadminid: TLinqProjection;
    function Fbibcode: TLinqProjection;
    function Fsafeqid: TLinqProjection;
    function Fzoomid: TLinqProjection;
    function Fcards: IcardDictionary;
    function Fcodes: IcodeDictionary;
    function Faddresses: IaddressDictionary;
  end;
  
  IDefaultDictionary = interface(IAureliusDictionary)
    function address: IaddressDictionary;
    function card: IcardDictionary;
    function code: IcodeDictionary;
    function person: IpersonDictionary;
  end;
  
  TDefaultDictionary = class(TAureliusDictionary, IDefaultDictionary)
  public
    function address: IaddressDictionary;
    function card: IcardDictionary;
    function code: IcodeDictionary;
    function person: IpersonDictionary;
  end;
  
function Dic: IDefaultDictionary;

implementation

var
  __Dic: IDefaultDictionary;

function Dic: IDefaultDictionary;
begin
  if __Dic = nil then __Dic := TDefaultDictionary.Create;
  result := __Dic;
end;

{ TaddressDictionary }

function TaddressDictionary.Fcpid_old2: TLinqProjection;
begin
  Result := Prop('Fcpid_old2');
end;

function TaddressDictionary.Fdate_created: TLinqProjection;
begin
  Result := Prop('Fdate_created');
end;

function TaddressDictionary.Fdate_changed: TLinqProjection;
begin
  Result := Prop('Fdate_changed');
end;

function TaddressDictionary.Fuser_created: TLinqProjection;
begin
  Result := Prop('Fuser_created');
end;

function TaddressDictionary.Fuser_changed: TLinqProjection;
begin
  Result := Prop('Fuser_changed');
end;

function TaddressDictionary.Femail: TLinqProjection;
begin
  Result := Prop('Femail');
end;

function TaddressDictionary.Femailprivate: TLinqProjection;
begin
  Result := Prop('Femailprivate');
end;

function TaddressDictionary.Ftel: TLinqProjection;
begin
  Result := Prop('Ftel');
end;

function TaddressDictionary.Ftelprivate: TLinqProjection;
begin
  Result := Prop('Ftelprivate');
end;

function TaddressDictionary.Fmobil: TLinqProjection;
begin
  Result := Prop('Fmobil');
end;

function TaddressDictionary.Fmobilprivate: TLinqProjection;
begin
  Result := Prop('Fmobilprivate');
end;

function TaddressDictionary.Fcompany1: TLinqProjection;
begin
  Result := Prop('Fcompany1');
end;

function TaddressDictionary.Fadditional1: TLinqProjection;
begin
  Result := Prop('Fadditional1');
end;

function TaddressDictionary.Fstreet1: TLinqProjection;
begin
  Result := Prop('Fstreet1');
end;

function TaddressDictionary.Fzipcode1: TLinqProjection;
begin
  Result := Prop('Fzipcode1');
end;

function TaddressDictionary.Fcity1: TLinqProjection;
begin
  Result := Prop('Fcity1');
end;

function TaddressDictionary.Fcountry1: TLinqProjection;
begin
  Result := Prop('Fcountry1');
end;

function TaddressDictionary.Fcompany2: TLinqProjection;
begin
  Result := Prop('Fcompany2');
end;

function TaddressDictionary.Fadditional2: TLinqProjection;
begin
  Result := Prop('Fadditional2');
end;

function TaddressDictionary.Fstreet2: TLinqProjection;
begin
  Result := Prop('Fstreet2');
end;

function TaddressDictionary.Fzipcode2: TLinqProjection;
begin
  Result := Prop('Fzipcode2');
end;

function TaddressDictionary.Fcity2: TLinqProjection;
begin
  Result := Prop('Fcity2');
end;

function TaddressDictionary.Fcountry2: TLinqProjection;
begin
  Result := Prop('Fcountry2');
end;

function TaddressDictionary.Fcoveraddress: TLinqProjection;
begin
  Result := Prop('Fcoveraddress');
end;

function TaddressDictionary.Fcomment: TLinqProjection;
begin
  Result := Prop('Fcomment');
end;

function TaddressDictionary.Fnew: TLinqProjection;
begin
  Result := Prop('Fnew');
end;

function TaddressDictionary.Fkpid: IpersonDictionary;
begin
  Result := TpersonDictionary.Create(PropName('Fkpid'));
end;

{ TcardDictionary }

function TcardDictionary.Fid: TLinqProjection;
begin
  Result := Prop('Fid');
end;

function TcardDictionary.Fidhex: TLinqProjection;
begin
  Result := Prop('Fidhex');
end;

function TcardDictionary.Fswid: TLinqProjection;
begin
  Result := Prop('Fswid');
end;

function TcardDictionary.Fdate_created: TLinqProjection;
begin
  Result := Prop('Fdate_created');
end;

function TcardDictionary.Fdate_changed: TLinqProjection;
begin
  Result := Prop('Fdate_changed');
end;

function TcardDictionary.Fbibswid: TLinqProjection;
begin
  Result := Prop('Fbibswid');
end;

function TcardDictionary.Fpid: IpersonDictionary;
begin
  Result := TpersonDictionary.Create(PropName('Fpid'));
end;

{ TcodeDictionary }

function TcodeDictionary.Fid: TLinqProjection;
begin
  Result := Prop('Fid');
end;

function TcodeDictionary.Fdate_created: TLinqProjection;
begin
  Result := Prop('Fdate_created');
end;

function TcodeDictionary.Fdate_changed: TLinqProjection;
begin
  Result := Prop('Fdate_changed');
end;

function TcodeDictionary.Fdate_checked: TLinqProjection;
begin
  Result := Prop('Fdate_checked');
end;

function TcodeDictionary.Fpass: TLinqProjection;
begin
  Result := Prop('Fpass');
end;

function TcodeDictionary.Fpass_freeradius: TLinqProjection;
begin
  Result := Prop('Fpass_freeradius');
end;

function TcodeDictionary.Fpass_ssha512: TLinqProjection;
begin
  Result := Prop('Fpass_ssha512');
end;

function TcodeDictionary.Funsec: TLinqProjection;
begin
  Result := Prop('Funsec');
end;

function TcodeDictionary.Fdate_temp: TLinqProjection;
begin
  Result := Prop('Fdate_temp');
end;

function TcodeDictionary.Fdate_lastchanged: TLinqProjection;
begin
  Result := Prop('Fdate_lastchanged');
end;

function TcodeDictionary.Fpid: IpersonDictionary;
begin
  Result := TpersonDictionary.Create(PropName('Fpid'));
end;

{ TpersonDictionary }

function TpersonDictionary.Fid: TLinqProjection;
begin
  Result := Prop('Fid');
end;

function TpersonDictionary.Fapid: TLinqProjection;
begin
  Result := Prop('Fapid');
end;

function TpersonDictionary.Fdate_created: TLinqProjection;
begin
  Result := Prop('Fdate_created');
end;

function TpersonDictionary.Fdate_changed: TLinqProjection;
begin
  Result := Prop('Fdate_changed');
end;

function TpersonDictionary.Fdate_checked: TLinqProjection;
begin
  Result := Prop('Fdate_checked');
end;

function TpersonDictionary.Fuser_created: TLinqProjection;
begin
  Result := Prop('Fuser_created');
end;

function TpersonDictionary.Fuser_changed: TLinqProjection;
begin
  Result := Prop('Fuser_changed');
end;

function TpersonDictionary.Flastname: TLinqProjection;
begin
  Result := Prop('Flastname');
end;

function TpersonDictionary.Fbirthname: TLinqProjection;
begin
  Result := Prop('Fbirthname');
end;

function TpersonDictionary.Ffirstname: TLinqProjection;
begin
  Result := Prop('Ffirstname');
end;

function TpersonDictionary.Fmiddlename: TLinqProjection;
begin
  Result := Prop('Fmiddlename');
end;

function TpersonDictionary.Fgender: TLinqProjection;
begin
  Result := Prop('Fgender');
end;

function TpersonDictionary.Fbirthdate: TLinqProjection;
begin
  Result := Prop('Fbirthdate');
end;

function TpersonDictionary.Fmail: TLinqProjection;
begin
  Result := Prop('Fmail');
end;

function TpersonDictionary.Femail_ksh: TLinqProjection;
begin
  Result := Prop('Femail_ksh');
end;

function TpersonDictionary.Flogin: TLinqProjection;
begin
  Result := Prop('Flogin');
end;

function TpersonDictionary.Flogin_old: TLinqProjection;
begin
  Result := Prop('Flogin_old');
end;

function TpersonDictionary.Flogin_new: TLinqProjection;
begin
  Result := Prop('Flogin_new');
end;

function TpersonDictionary.Flogin_new_activated: TLinqProjection;
begin
  Result := Prop('Flogin_new_activated');
end;

function TpersonDictionary.Fapid2: TLinqProjection;
begin
  Result := Prop('Fapid2');
end;

function TpersonDictionary.Fkpid2: TLinqProjection;
begin
  Result := Prop('Fkpid2');
end;

function TpersonDictionary.Fcomment: TLinqProjection;
begin
  Result := Prop('Fcomment');
end;

function TpersonDictionary.Ferledigt_alt: TLinqProjection;
begin
  Result := Prop('Ferledigt_alt');
end;

function TpersonDictionary.Fpolid: TLinqProjection;
begin
  Result := Prop('Fpolid');
end;

function TpersonDictionary.Fcpid_old: TLinqProjection;
begin
  Result := Prop('Fcpid_old');
end;

function TpersonDictionary.Fcpid2: TLinqProjection;
begin
  Result := Prop('Fcpid2');
end;

function TpersonDictionary.Fdeactivated: TLinqProjection;
begin
  Result := Prop('Fdeactivated');
end;

function TpersonDictionary.Fsalutation: TLinqProjection;
begin
  Result := Prop('Fsalutation');
end;

function TpersonDictionary.Fmnr: TLinqProjection;
begin
  Result := Prop('Fmnr');
end;

function TpersonDictionary.Fbirthcity: TLinqProjection;
begin
  Result := Prop('Fbirthcity');
end;

function TpersonDictionary.Fbirthcountryid: TLinqProjection;
begin
  Result := Prop('Fbirthcountryid');
end;

function TpersonDictionary.Fbirthcountry: TLinqProjection;
begin
  Result := Prop('Fbirthcountry');
end;

function TpersonDictionary.Fsalutationletter: TLinqProjection;
begin
  Result := Prop('Fsalutationletter');
end;

function TpersonDictionary.Fsalutationspecial: TLinqProjection;
begin
  Result := Prop('Fsalutationspecial');
end;

function TpersonDictionary.Ftitlepre: TLinqProjection;
begin
  Result := Prop('Ftitlepre');
end;

function TpersonDictionary.Ftitlepost: TLinqProjection;
begin
  Result := Prop('Ftitlepost');
end;

function TpersonDictionary.Ftitle_academic: TLinqProjection;
begin
  Result := Prop('Ftitle_academic');
end;

function TpersonDictionary.Ftitle_job: TLinqProjection;
begin
  Result := Prop('Ftitle_job');
end;

function TpersonDictionary.Fcompany: TLinqProjection;
begin
  Result := Prop('Fcompany');
end;

function TpersonDictionary.Fposition: TLinqProjection;
begin
  Result := Prop('Fposition');
end;

function TpersonDictionary.Fdead: TLinqProjection;
begin
  Result := Prop('Fdead');
end;

function TpersonDictionary.Fdate_of_death: TLinqProjection;
begin
  Result := Prop('Fdate_of_death');
end;

function TpersonDictionary.Fpass2: TLinqProjection;
begin
  Result := Prop('Fpass2');
end;

function TpersonDictionary.Fparental: TLinqProjection;
begin
  Result := Prop('Fparental');
end;

function TpersonDictionary.Funsec2: TLinqProjection;
begin
  Result := Prop('Funsec2');
end;

function TpersonDictionary.Fdate_temp2: TLinqProjection;
begin
  Result := Prop('Fdate_temp2');
end;

function TpersonDictionary.Fdate_neu: TLinqProjection;
begin
  Result := Prop('Fdate_neu');
end;

function TpersonDictionary.Fcitizenship1: TLinqProjection;
begin
  Result := Prop('Fcitizenship1');
end;

function TpersonDictionary.Fcitizenship2: TLinqProjection;
begin
  Result := Prop('Fcitizenship2');
end;

function TpersonDictionary.Fadaid: TLinqProjection;
begin
  Result := Prop('Fadaid');
end;

function TpersonDictionary.Fmobilephone: TLinqProjection;
begin
  Result := Prop('Fmobilephone');
end;

function TpersonDictionary.Femailsignature: TLinqProjection;
begin
  Result := Prop('Femailsignature');
end;

function TpersonDictionary.Froomlabel: TLinqProjection;
begin
  Result := Prop('Froomlabel');
end;

function TpersonDictionary.Flrzid: TLinqProjection;
begin
  Result := Prop('Flrzid');
end;

function TpersonDictionary.Fswcardid: TLinqProjection;
begin
  Result := Prop('Fswcardid');
end;

function TpersonDictionary.Froomnr: TLinqProjection;
begin
  Result := Prop('Froomnr');
end;

function TpersonDictionary.Fphonepin: TLinqProjection;
begin
  Result := Prop('Fphonepin');
end;

function TpersonDictionary.Ffunction_internal: TLinqProjection;
begin
  Result := Prop('Ffunction_internal');
end;

function TpersonDictionary.Fphone_internal: TLinqProjection;
begin
  Result := Prop('Fphone_internal');
end;

function TpersonDictionary.Fqualification: TLinqProjection;
begin
  Result := Prop('Fqualification');
end;

function TpersonDictionary.Furl_extern: TLinqProjection;
begin
  Result := Prop('Furl_extern');
end;

function TpersonDictionary.Fmoodleid: TLinqProjection;
begin
  Result := Prop('Fmoodleid');
end;

function TpersonDictionary.Fhsadminid: TLinqProjection;
begin
  Result := Prop('Fhsadminid');
end;

function TpersonDictionary.Fbibcode: TLinqProjection;
begin
  Result := Prop('Fbibcode');
end;

function TpersonDictionary.Fsafeqid: TLinqProjection;
begin
  Result := Prop('Fsafeqid');
end;

function TpersonDictionary.Fzoomid: TLinqProjection;
begin
  Result := Prop('Fzoomid');
end;

function TpersonDictionary.Fcards: IcardDictionary;
begin
  Result := TcardDictionary.Create(PropName('Fcards'));
end;

function TpersonDictionary.Fcodes: IcodeDictionary;
begin
  Result := TcodeDictionary.Create(PropName('Fcodes'));
end;

function TpersonDictionary.Faddresses: IaddressDictionary;
begin
  Result := TaddressDictionary.Create(PropName('Faddresses'));
end;

{ TDefaultDictionary }

function TDefaultDictionary.address: IaddressDictionary;
begin
  Result := TaddressDictionary.Create;
end;

function TDefaultDictionary.card: IcardDictionary;
begin
  Result := TcardDictionary.Create;
end;

function TDefaultDictionary.code: IcodeDictionary;
begin
  Result := TcodeDictionary.Create;
end;

function TDefaultDictionary.person: IpersonDictionary;
begin
  Result := TpersonDictionary.Create;
end;

end.
